//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
#include "Unit4.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
bool WriteTo()
{DWORD temp;

 WriteFile(Port,wr_buf,wr_buf_len,&temp,&ovr_wr); //   
 WaitForSingleObject(ovr_wr.hEvent,30000);        //   30         
 if(GetOverlappedResult(Port,&ovr_wr,&temp,true)) return true;  //    -  
 else                                             return false; //  - 
}
//---------------------------------------------------------------------------
bool ReadFrom(int WaitingBytes)
{ COMSTAT    port_status;
  DWORD      temp, mask;
  int        Counter;

 Counter=0;
 while(Counter<1000) //   1000 
 { ClearCommError(Port,&temp,&port_status);    //  port_status
   rd_buf_len=0;
   rd_buf_len=port_status.cbInQue;  //-  
   if(rd_buf_len>=WaitingBytes)     //  ,    
   {
     ReadFile(Port,rd_buf,rd_buf_len,&temp,&ovr_rd);  //  - 
     return true;
   }
   Counter++;
   Sleep(1);
 }
 return false;
}
//---------------------------------------------------------------------------
void OpenPort()
{ dcb.DCBlength=sizeof(DCB);
  //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";
  strcat(PortName,Form1->ComboBox1->Text.c_str());
  Port=CreateFile(PortName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
  if(Port==INVALID_HANDLE_VALUE)
  { MessageBox(NULL,"  ","Error",MB_OK);
    return;
  }
  else
  { if(GetCommState(Port,&dcb)==0)
    { MessageBox(NULL,"   ","Error",MB_OK);
      CloseHandle(Port);
      Port=INVALID_HANDLE_VALUE;
      return;
    }
    else
    { switch(SelectedProgrammer)
      { case 1:  dcb.BaudRate=115200;
                 break;
        case2:
        default:
                 dcb.BaudRate=250000;
      }
      dcb.ByteSize=8;
      dcb.Parity=0;
      dcb.StopBits=2;
      dcb.fBinary=true;          //  
      dcb.fOutxCtsFlow=false;    //  CTS
      dcb.fOutxDsrFlow=false;    //  DSR
      dcb.fDtrControl=DTR_CONTROL_DISABLE;     // DTR
      dcb.fDsrSensitivity=false;               //  DSR
      dcb.fNull=false;           //  
      dcb.fRtsControl=RTS_CONTROL_DISABLE;    // RTS
      dcb.fAbortOnError=false;   //  /  
    }
    if(SetCommState(Port,&dcb)==0)
    { MessageBox(NULL,"   ","Error",MB_OK);
      CloseHandle(Port);
      Port=INVALID_HANDLE_VALUE;
      return;
    }

    memset(wr_buf,0,BUFSIZE);        //    
    wr_buf_len=0;                    //  
    SetupComm(Port,BUFSIZE+100,BUFSIZE+100);       //    
    PurgeComm(Port,PURGE_RXCLEAR|PURGE_TXCLEAR);   //     

    Form1->Button1->Enabled=true;
    Form1->Button2->Enabled=true;
    Form1->Button3->Enabled=false;
    Form1->Button4->Enabled=true;

    //  
    wr_buf_len=8;
    wr_buf[0]=0x0A;     // disable autoload
    wr_buf[1]=0x08;     // disable reports
    wr_buf[2]=0x02;     // select SPI
    wr_buf[3]=0x42;     // Send SPI packet size
    wr_buf[4]=0x19;     // 0x19 = 25 - packet size = 25 bit
    wr_buf[5]=0x40;     // Send SPI config
    wr_buf[6]=0x07;     // 0x07 = b00000111 - high first, mode 3
    wr_buf[7]=0x47;     // Clear SS
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     ClosePort();
                   }
    Sleep(Delays); //////////////////////////////
    if(SelectedProgrammer==2)
    {    //---     ---
         //   PORTC
         wr_buf_len=1;
         wr_buf[0]=0x12;     // PORTCRead
         if(!WriteTo()) { MessageBox(NULL,"  PORTC","Error",MB_OK);
                          ClosePort();
                        }
         Sleep(Delays); //////////////////////////////
         //  ,  PORTC
         if(!ReadFrom(1)){ MessageBox(NULL,"  PORTC","Error",MB_OK);
                           LBar->Free();        //    -
                           ClosePort();
                           return;
                         }
         Sleep(Delays); //////////////////////////////
         wr_buf_len=2;
         wr_buf[0] = 0x11;   // PORTCSetup
         wr_buf[1] = rd_buf[0] & 0xFB; //   2
         if(!WriteTo()) { MessageBox(NULL,"  PORTC","Error",MB_OK);
                          ClosePort();
                        }
         //   DDRC
         wr_buf_len=1;
         wr_buf[0]=0x10;     // DDRCRead
         if(!WriteTo()) { MessageBox(NULL,"  PORTC","Error",MB_OK);
                          ClosePort();
                        }
         Sleep(Delays); //////////////////////////////
         //  ,  DDRC
         if(!ReadFrom(1)){ MessageBox(NULL,"  DDRC","Error",MB_OK);
                           LBar->Free();        //    -
                           ClosePort();
                           return;
                         }
         Sleep(Delays); //////////////////////////////
         wr_buf_len=2;
         wr_buf[0] = 0x0F;   // DDRCSetup
         wr_buf[1] = rd_buf[0] | 0x4; //   2
         if(!WriteTo()) { MessageBox(NULL,"  DDRC","Error",MB_OK);
                          ClosePort();
                        }
         Sleep(Delays); //////////////////////////////
    }
  }
}
//---------------------------------------------------------------------------
void ClosePort()
{ CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
  Form1->Button1->Enabled=false;
  Form1->Button2->Enabled=false;
  Form1->Button3->Enabled=true;
  Form1->Button4->Enabled=false;
}
//---------------------------------------------------------------------------
void BuildMemory()
{ int i; AnsiString Temp;
  //  1,2,3
  Form1->RichEdit1->Clear(); Form1->RichEdit2->Clear(); Form1->RichEdit3->Clear();
  Form1->RichEdit1->Visible=false; Form1->RichEdit2->Visible=false; Form1->RichEdit3->Visible=false;
  for(i=0; i<(SelectedChip.Size*SelectedChip.ByteInWord-1)/8+1 ; i++)
   { Form1->RichEdit1->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
     Form1->RichEdit2->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
     Form1->RichEdit3->Lines->Add(IntToHex(8*i,4)+": FF FF FF FF FF FF FF FF   |   ");
   }
  //     
  Form1->RichEdit1->SelStart=46*(i-1)+44;
  Form1->RichEdit1->SelLength=2;
  Form1->RichEdit1->SelText="";
  Form1->RichEdit2->SelStart=46*(i-1)+44;
  Form1->RichEdit2->SelLength=2;
  Form1->RichEdit2->SelText="";
  Form1->RichEdit3->SelStart=46*(i-1)+44;
  Form1->RichEdit3->SelLength=2;
  Form1->RichEdit3->SelText="";
  //   hipName    
  Form1->Edit1->Text=SelectedChip.Name;
  Form1->RichEdit1->Visible=true; Form1->RichEdit2->Visible=true; Form1->RichEdit3->Visible=true;
  Form1->Caption="SPI EPROM Programmer";
}
//---------------------------------------------------------------------------
void ChangeLeftRight(int PositionGlobal, int PositionLocal, int LineNumber, char Key)
{ int  TempPositionGlobalR, TempPositionGlobalL;
  bool ChangeLeft, ChangeRight;
  AnsiString TempStr;
  char buf[2], value[1], hexbuf[3];
  unsigned char TempChar;
  char *Charset1="0123456789abcdefABCDEF";

 ChangeLeft=false; ChangeRight=false;
 switch(PositionLocal)
  { case 6: case 7:   TempPositionGlobalR=LineNumber*46+36; //   ,    
                      TempPositionGlobalL=46*LineNumber+6;  //   ,       
                      ChangeLeft=true; //   
                      break;
    case 9: case 10:  TempPositionGlobalR=LineNumber*46+37; //   ,    
                      TempPositionGlobalL=46*LineNumber+9;  //   ,       
                      ChangeLeft=true; //   
                      break;
    case 12: case 13: TempPositionGlobalR=LineNumber*46+38; //   ,    
                      TempPositionGlobalL=46*LineNumber+12; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 15: case 16: TempPositionGlobalR=LineNumber*46+39; //   ,    
                      TempPositionGlobalL=46*LineNumber+15; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 18: case 19: TempPositionGlobalR=LineNumber*46+40; //   ,    
                      TempPositionGlobalL=46*LineNumber+18; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 21: case 22: TempPositionGlobalR=LineNumber*46+41; //   ,    
                      TempPositionGlobalL=46*LineNumber+21; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 24: case 25: TempPositionGlobalR=LineNumber*46+42; //   ,    
                      TempPositionGlobalL=46*LineNumber+24; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 27: case 28: TempPositionGlobalR=LineNumber*46+43; //   ,    
                      TempPositionGlobalL=46*LineNumber+27; //   ,       
                      ChangeLeft=true; //   
                      break;
    case 36: TempPositionGlobalR=LineNumber*46+36; //   ,    
             TempPositionGlobalL=46*LineNumber+6;  //   ,       
             ChangeRight=true; //   
             break;
    case 37: TempPositionGlobalR=LineNumber*46+37; //   ,    
             TempPositionGlobalL=46*LineNumber+9;  //   ,       
             ChangeRight=true; //   
             break;
    case 38: TempPositionGlobalR=LineNumber*46+38; //   ,    
             TempPositionGlobalL=46*LineNumber+12; //   ,       
             ChangeRight=true; //   
             break;
    case 39: TempPositionGlobalR=LineNumber*46+39; //   ,    
             TempPositionGlobalL=46*LineNumber+15; //   ,       
             ChangeRight=true; //   
             break;
    case 40: TempPositionGlobalR=LineNumber*46+40; //   ,    
             TempPositionGlobalL=46*LineNumber+18; //   ,       
             ChangeRight=true; //   
             break;
    case 41: TempPositionGlobalR=LineNumber*46+41; //   ,    
             TempPositionGlobalL=46*LineNumber+21; //   ,       
             ChangeRight=true; //   
             break;
    case 42: TempPositionGlobalR=LineNumber*46+42; //   ,    
             TempPositionGlobalL=46*LineNumber+24; //   ,       
             ChangeRight=true; //   
             break;
    case 43: TempPositionGlobalR=LineNumber*46+43; //   ,    
             TempPositionGlobalL=46*LineNumber+27; //   ,       
             ChangeRight=true; //   
             break;
  }
  bool Choice = (strchr(Charset1,Key))||(BS_FLAG);
  if(ChangeLeft && Choice)
  { //    
    if(Key==0x2E||BS_FLAG==true) Key=0x46;                    //   -   "F"
    switch(Form1->PageControl1->TabIndex)
    { case 0: Form1->RichEdit1->SelStart=PositionGlobal;      //     
              Form1->RichEdit1->SelLength=1;                  //  1 
              Form1->RichEdit1->SelText=Key;                  // 
              Form1->RichEdit1->SelStart=PositionGlobal;      //     
              Form1->RichEdit1->SelLength=1;                  //  1 
              Form1->RichEdit1->SelText=UpperCase(Form1->RichEdit1->SelText);//      
              //    
              Form1->RichEdit1->SelStart=TempPositionGlobalL; //     
              Form1->RichEdit1->SelLength=2;                  //  2 
              TempStr=LowerCase(Form1->RichEdit1->SelText);   //    
              break;
      case 1: Form1->RichEdit2->SelStart=PositionGlobal;      //     
              Form1->RichEdit2->SelLength=1;                  //  1 
              Form1->RichEdit2->SelText=Key;                  // 
              Form1->RichEdit2->SelStart=PositionGlobal;      //     
              Form1->RichEdit2->SelLength=1;                  //  1 
              Form1->RichEdit2->SelText=UpperCase(Form1->RichEdit2->SelText);//      
              //    
              Form1->RichEdit2->SelStart=TempPositionGlobalL; //     
              Form1->RichEdit2->SelLength=2;                  //  2 
              TempStr=LowerCase(Form1->RichEdit2->SelText);   //    
              break;
      case 2: Form1->RichEdit3->SelStart=PositionGlobal;      //     
              Form1->RichEdit3->SelLength=1;                  //  1 
              Form1->RichEdit3->SelText=Key;                  // 
              Form1->RichEdit3->SelStart=PositionGlobal;      //     
              Form1->RichEdit3->SelLength=1;                  //  1 
              Form1->RichEdit3->SelText=UpperCase(Form1->RichEdit3->SelText);//      
              //    
              Form1->RichEdit3->SelStart=TempPositionGlobalL; //     
              Form1->RichEdit3->SelLength=2;                  //  2 
              TempStr=LowerCase(Form1->RichEdit3->SelText);   //    
    }
    memset(buf,0,2);                                //  
    strcat(buf,TempStr.c_str());                    //      (  )
    HexToBin(buf,value,1);                          //    ()
    TempChar=value[0];
    if(TempChar<0x1F) value[0]=0x1F; // 
    switch(Form1->PageControl1->TabIndex)
    { case 0: //    
              Form1->RichEdit1->SelStart=TempPositionGlobalR; //     
              Form1->RichEdit1->SelLength=1;                  //  1 
              Form1->RichEdit1->SelText=value[0];             //    value
              //    
              Form1->RichEdit1->SelStart=PositionGlobal;      //     
              Form1->RichEdit1->SelLength=0;                  //  
              break;
      case 1: //    
              Form1->RichEdit2->SelStart=TempPositionGlobalR; //     
              Form1->RichEdit2->SelLength=1;                  //  1 
              Form1->RichEdit2->SelText=value[0];             //    value
              //    
              Form1->RichEdit2->SelStart=PositionGlobal;      //     
              Form1->RichEdit2->SelLength=0;                  //  
              break;
      case 2: //    
              Form1->RichEdit3->SelStart=TempPositionGlobalR; //     
              Form1->RichEdit3->SelLength=1;                  //  1 
              Form1->RichEdit3->SelText=value[0];             //    value
              //    
              Form1->RichEdit3->SelStart=PositionGlobal;      //     
              Form1->RichEdit3->SelLength=0;                  //  
    }
  }
  if(ChangeRight)
  { if(Key==0x2E||BS_FLAG==true) Key=0xFF;                   //   -   ""
    switch(Form1->PageControl1->TabIndex)
    { case 0: //    
              Form1->RichEdit1->SelStart=PositionGlobal;     //     
              Form1->RichEdit1->SelLength=1;                 //  1 
              Form1->RichEdit1->SelText=Key;                 // 
              break;
      case 1: //    
              Form1->RichEdit2->SelStart=PositionGlobal;     //     
              Form1->RichEdit2->SelLength=1;                 //  1 
              Form1->RichEdit2->SelText=Key;                 // 
              break;
      case 2: //    
              Form1->RichEdit3->SelStart=PositionGlobal;     //     
              Form1->RichEdit3->SelLength=1;                 //  1 
              Form1->RichEdit3->SelText=Key;                 // 
    }
    //   
    value[0]=Key;
    BinToHex(value,hexbuf,1);                      //    ()
    hexbuf[2]=0;                                   //   
    switch(Form1->PageControl1->TabIndex)
    { case 0: Form1->RichEdit1->SelStart=TempPositionGlobalL;//     
              Form1->RichEdit1->SelLength=2;                 //  1 
              Form1->RichEdit1->SelText=hexbuf;              //   hexbuf (2   -,    )
              Form1->RichEdit1->SelStart=PositionGlobal;     //    
              Form1->RichEdit1->SelLength=0;                 //  
              break;
      case 1: Form1->RichEdit2->SelStart=TempPositionGlobalL;//     
              Form1->RichEdit2->SelLength=2;                 //  1 
              Form1->RichEdit2->SelText=hexbuf;              //   hexbuf (2   -,    )
              Form1->RichEdit2->SelStart=PositionGlobal;     //    
              Form1->RichEdit2->SelLength=0;                 //  
              break;
      case 2: Form1->RichEdit3->SelStart=TempPositionGlobalL;//     
              Form1->RichEdit3->SelLength=2;                 //  1 
              Form1->RichEdit3->SelText=hexbuf;              //   hexbuf (2   -,    )
              Form1->RichEdit3->SelStart=PositionGlobal;     //    
              Form1->RichEdit3->SelLength=0;                 //  
    }
  }
}
//---------------------------------------------------------------------------
void LoadHexFile()
{ AnsiString tempstr, tempsubstr;
  unsigned char *hexbuf, tempbuf[1];
  char Symbol[2];
  unsigned int i, j, n, templinenumber, templocaladdr,
               Reclen, Offset, Rectyp, position,
               LinearBaseAddress, SegmentBaseAddress;
  int Address;

  LinearBaseAddress=0;
  SegmentBaseAddress=0;

  n=Form1->Memo1->Lines->Count;//   
  for(i=0;i<n;i++)
  { tempstr=Form1->Memo1->Lines->Strings[i];
    //- - 
    tempsubstr=tempstr.SubString(2,2);//- -     
    hexbuf=tempsubstr.c_str();
    HexToBin(hexbuf,tempbuf,1);
    Reclen=tempbuf[0];
    //   
    tempsubstr=tempstr.SubString(4,4);//    
    hexbuf=tempsubstr.c_str();
    HexToBin(hexbuf,tempbuf,2);
    Offset=tempbuf[0]*256+tempbuf[1];
    //  
    tempsubstr=tempstr.SubString(8,2);//     
    hexbuf=tempsubstr.c_str();
    HexToBin(hexbuf,tempbuf,1);
    Rectyp=tempbuf[0];
    switch(Rectyp)
    { //Data record
      case 0:
      for(j=0;j<Reclen;j++)
      { tempsubstr=tempstr.SubString(10+2*j,2);
        Address=LinearBaseAddress+SegmentBaseAddress+Offset+j;// 

        if(Address<SelectedChip.Size*SelectedChip.ByteInWord)
        { templinenumber=Address/8;                // ,    
          templocaladdr=Address-8*templinenumber;  //   
          //if(SelectedChip.AddrSize==2)//   2 
          //{ if(templocaladdr&1)       //     ,       ( ,  )
          //       { templocaladdr-=1; }//  ,   1
          //  else { templocaladdr+=1; }//  -  1
          //}
          hexbuf=tempsubstr.c_str();           // tempsubstr -     hex (  )
          HexToBin(hexbuf,tempbuf,1);
          if(tempbuf[0]<0x1F) tempbuf[0]=0x1F; // tempbuf[0] -      (  )
          Symbol[0]=tempbuf[0]; Symbol[1]=0;
          //   
          switch(Form1->PageControl1->TabIndex)
          { case 0: Form1->RichEdit1->SelStart=templinenumber*46+36+templocaladdr; //     
                    Form1->RichEdit1->SelLength=1;         //  1 
                    Form1->RichEdit1->SelText=Symbol[0];   // 
                    Form1->RichEdit1->SelLength=0;
                    break;
            case 1: Form1->RichEdit2->SelStart=templinenumber*46+36+templocaladdr; //     
                    Form1->RichEdit2->SelLength=1;          //  1 
                    Form1->RichEdit2->SelText=Symbol[0];   // 
                    Form1->RichEdit2->SelLength=0;
                    break;
            case 2: Form1->RichEdit3->SelStart=templinenumber*46+36+templocaladdr; //     
                    Form1->RichEdit3->SelLength=1;          //  1 
                    Form1->RichEdit3->SelText=Symbol[0];   // 
                    Form1->RichEdit3->SelLength=0;
          }
          //   
          switch(Form1->PageControl1->TabIndex)
          { case 0: Form1->RichEdit1->SelStart=templinenumber*46+6+3*templocaladdr;//     
                    Form1->RichEdit1->SelLength=2;                 //  1 
                    Form1->RichEdit1->SelText=tempsubstr;          //   hexbuf (2   -,    )
                    Form1->RichEdit1->SelStart=6;                  //    
                    Form1->RichEdit1->SelLength=0;                 //  
                    break;
            case 1: Form1->RichEdit2->SelStart=templinenumber*46+6+3*templocaladdr;//     
                    Form1->RichEdit2->SelLength=2;                 //  1 
                    Form1->RichEdit2->SelText=tempsubstr;          //   hexbuf (2   -,    )
                    Form1->RichEdit2->SelStart=6;                  //    
                    Form1->RichEdit2->SelLength=0;                 //  
                    break;
            case 2: Form1->RichEdit3->SelStart=templinenumber*46+6+3*templocaladdr;//     
                    Form1->RichEdit3->SelLength=2;                 //  1 
                    Form1->RichEdit3->SelText=tempsubstr;          //   hexbuf (2   -,    )
                    Form1->RichEdit3->SelStart=6;                  //    
                    Form1->RichEdit3->SelLength=0;                 //  
          }
        }
      }
      break;
      //End of file record
      case 1: Form1->Caption=FilePath;
              return;
      //Extended segment address record
      case 2: tempsubstr=tempstr.SubString(10,4);//     
              hexbuf=tempsubstr.c_str();
              HexToBin(hexbuf,tempbuf,2);
              SegmentBaseAddress=(tempbuf[0]*256+tempbuf[1])*16;
              break;
      //Start segment address record (  4-19   
      // ,       )
      case 3: MessageBox(NULL," HEX-  8086/80186","Error",MB_OK);
              return;
      //Extended linear address record (  2    
      // ,       )
      case 4: tempsubstr=tempstr.SubString(10,4);//     
              hexbuf=tempsubstr.c_str();
              HexToBin(hexbuf,tempbuf,2);
              LinearBaseAddress=(tempbuf[0]*256+tempbuf[1])*65536;
              break;
      //Start linear address record
      case 5: MessageBox(NULL," HEX-  80386","Error",MB_OK);
              return;
      //       - 
      default:MessageBox(NULL,"  !","Error",MB_OK);
              return;
    }
    LBar->ProgressBar1->Position=100*i/n; //    -
  }
  MessageBox(NULL,"   ","Error",MB_OK);
}
//--------------------------------------------------------------------------
//---       -----------------------
//--------------------------------------------------------------------------
void SwitchToSelectedHW(int V)
{  SelectedProgrammer = V;
   switch(SelectedProgrammer)
   { case 1:    Form1->MainMenu1->Items->Items[2]->Items[0]->Caption = "* RH-0004";
                Form1->MainMenu1->Items->Items[2]->Items[1]->Caption = "   RH-0010";
                Form1->RadioButton1->Checked=true;
                break;
     case 2:    Form1->MainMenu1->Items->Items[2]->Items[0]->Caption = "   RH-0004";
                Form1->MainMenu1->Items->Items[2]->Items[1]->Caption = "* RH-0010";
                Form1->RadioButton2->Checked=true;
     default:   break;
   }
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Form1->AutoSize=true;
  Button1->Enabled=false;
  Button2->Enabled=false;
  Button3->Enabled=true;
  Button4->Enabled=false;
  SelectedChip.Name="93C06"; SelectedChip.Model=1; SelectedChip.Size=16; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }

  SelectedProgrammer=2;                 // -   RH-0010
  SwitchToSelectedHW(SelectedProgrammer);       //      
  Delays = Form1->TrackBar1->Position;  //     (-   0)
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ OpenPort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{ ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{ //   ,    
  if(Port!=INVALID_HANDLE_VALUE) ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ if(Port!=INVALID_HANDLE_VALUE) ClosePort();
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{ AboutBox->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Readme1Click(TObject *Sender)
{   Readme->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N93C061Click(TObject *Sender)
{ SelectedChip.Name="93C06"; SelectedChip.Model=1; SelectedChip.Size=16; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N93C461Click(TObject *Sender)
{ SelectedChip.Name="93C46"; SelectedChip.Model=2; SelectedChip.Size=64; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------//---------------------------------------------------------------------------
void __fastcall TForm1::N93C571Click(TObject *Sender)
{ SelectedChip.Name="93C57"; SelectedChip.Model=3; SelectedChip.Size=128; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N93C561Click(TObject *Sender)
{ SelectedChip.Name="93C56"; SelectedChip.Model=4; SelectedChip.Size=128; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N93C661Click(TObject *Sender)
{ SelectedChip.Name="93C66"; SelectedChip.Model=5; SelectedChip.Size=256; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N93C761Click(TObject *Sender)
{ SelectedChip.Name="93C76"; SelectedChip.Model=6; SelectedChip.Size=512; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N93C861Click(TObject *Sender)
{ SelectedChip.Name="93C86"; SelectedChip.Model=7; SelectedChip.Size=1024; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::NM93C131Click(TObject *Sender)
{ SelectedChip.Name="NM93C13"; SelectedChip.Model=8; SelectedChip.Size=16; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::NM93C141Click(TObject *Sender)
{ SelectedChip.Name="NM93C14"; SelectedChip.Model=9; SelectedChip.Size=64; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AT59C111Click(TObject *Sender)
{ SelectedChip.Name="AT59C11"; SelectedChip.Model=10; SelectedChip.Size=64; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AT59C221Click(TObject *Sender)
{ SelectedChip.Name="AT59C22"; SelectedChip.Model=11; SelectedChip.Size=128; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AT59C131Click(TObject *Sender)
{ SelectedChip.Name="AT59C13"; SelectedChip.Model=12; SelectedChip.Size=256; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_1.jpg")) Image1->Picture->LoadFromFile("spi_prog_1.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AK6420A1Click(TObject *Sender)
{ SelectedChip.Name="AK6420A"; SelectedChip.Model=13; SelectedChip.Size=128; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_2.jpg")) Image1->Picture->LoadFromFile("spi_prog_2.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AK6440A1Click(TObject *Sender)
{ SelectedChip.Name="AK6440A"; SelectedChip.Model=14; SelectedChip.Size=256; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_2.jpg")) Image1->Picture->LoadFromFile("spi_prog_2.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AK6480A1Click(TObject *Sender)
{ SelectedChip.Name="AK6480A"; SelectedChip.Model=15; SelectedChip.Size=512; SelectedChip.ByteInWord=2;
  BuildMemory();
  if(FileExists("spi_prog_2.jpg")) Image1->Picture->LoadFromFile("spi_prog_2.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AT250101Click(TObject *Sender)
{ SelectedChip.Name="25010"; SelectedChip.Model=16; SelectedChip.Size=128; SelectedChip.ByteInWord=1;
  BuildMemory();
  if(FileExists("spi_prog_3.jpg")) Image1->Picture->LoadFromFile("spi_prog_3.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AT250201Click(TObject *Sender)
{ SelectedChip.Name="25020"; SelectedChip.Model=17; SelectedChip.Size=256; SelectedChip.ByteInWord=1;
  BuildMemory();
  if(FileExists("spi_prog_3.jpg")) Image1->Picture->LoadFromFile("spi_prog_3.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AT250401Click(TObject *Sender)
{ SelectedChip.Name="25040"; SelectedChip.Model=18; SelectedChip.Size=512; SelectedChip.ByteInWord=1;
  BuildMemory();
  if(FileExists("spi_prog_3.jpg")) Image1->Picture->LoadFromFile("spi_prog_3.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N250801Click(TObject *Sender)
{ SelectedChip.Name="25080"; SelectedChip.Model=19; SelectedChip.Size=1024; SelectedChip.ByteInWord=1;
  BuildMemory();
  if(FileExists("spi_prog_3.jpg")) Image1->Picture->LoadFromFile("spi_prog_3.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N2501Click(TObject *Sender)
{ SelectedChip.Name="25160"; SelectedChip.Model=20; SelectedChip.Size=2048; SelectedChip.ByteInWord=1;
  BuildMemory();
  if(FileExists("spi_prog_3.jpg")) Image1->Picture->LoadFromFile("spi_prog_3.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N253201Click(TObject *Sender)
{ SelectedChip.Name="25320"; SelectedChip.Model=21; SelectedChip.Size=4096; SelectedChip.ByteInWord=1;
  BuildMemory();
  if(FileExists("spi_prog_3.jpg")) Image1->Picture->LoadFromFile("spi_prog_3.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N256401Click(TObject *Sender)
{ SelectedChip.Name="25640"; SelectedChip.Model=22; SelectedChip.Size=8192; SelectedChip.ByteInWord=1;
  BuildMemory();
  if(FileExists("spi_prog_3.jpg")) Image1->Picture->LoadFromFile("spi_prog_3.jpg");
  else                           { MessageBox(NULL,"   ,\n(   ).  \n ,    \n   radiohlam.ru","Error",MB_OK);
                                   Image1->Picture->Bitmap->FreeImage(); }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ int  PositionGlobal, LineNumber, PositionLocal;

  switch(PageControl1->TabIndex)
  { case 0: PositionGlobal=Form1->RichEdit1->SelStart;  //    
            break;
    case 1: PositionGlobal=Form1->RichEdit2->SelStart;  //    
            break;
    case 2: PositionGlobal=Form1->RichEdit3->SelStart;  //    
  }
  LineNumber=PositionGlobal/46;               //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber; //    
  int MaxLineNumber = (SelectedChip.Size*SelectedChip.ByteInWord-1)/8;//   

  BS_FLAG=false;
  switch(Key)
   { //*********************************************************
     //   BackSpace ***************************
     case 8:  Key=0x25;
              //   
              if(PositionLocal==6)
              { if(LineNumber==0)  PositionGlobal=MaxLineNumber*46+29;
                else               PositionGlobal=(LineNumber-1)*46+29;
                Key=0;
              }
              if(PositionLocal==36)
              { if(LineNumber==0)  PositionGlobal=MaxLineNumber*46+44;
                else               PositionGlobal=(LineNumber-1)*46+44;
                Key=0;
              }
              switch(PageControl1->TabIndex)
              { case 0: Form1->RichEdit1->SelStart=PositionGlobal;   //  
                        Form1->RichEdit1->SelLength=0;               //  
                        break;
                case 1: Form1->RichEdit2->SelStart=PositionGlobal;   //  
                        Form1->RichEdit2->SelLength=0;               //  
                        break;
                case 2: Form1->RichEdit3->SelStart=PositionGlobal;   //  
                        Form1->RichEdit3->SelLength=0;               //  
              }
              //   BackSpace
              BS_FLAG=true;
              return;
     //*********************************************************
     //   Delete ******************************
     case 0x2E: ChangeLeftRight(PositionGlobal, PositionLocal, LineNumber, Key);
                //   
                if(PositionLocal==29)
                { if(LineNumber==MaxLineNumber)  PositionGlobal=5;
                  else                           PositionGlobal=(LineNumber+1)*46+5;
                }
                if(PositionLocal==44)
                { if(LineNumber==MaxLineNumber)  PositionGlobal=35;
                  else                           PositionGlobal=(LineNumber+1)*46+35;
                }
                switch(PageControl1->TabIndex)
                { case 0: Form1->RichEdit1->SelStart=PositionGlobal;   //  
                          Form1->RichEdit1->SelLength=0;               //  
                          break;
                  case 1: Form1->RichEdit2->SelStart=PositionGlobal;   //  
                          Form1->RichEdit2->SelLength=0;               //  
                          break;
                  case 2: Form1->RichEdit3->SelStart=PositionGlobal;   //  
                          Form1->RichEdit3->SelLength=0;               //  
                }
                Key=0x27;
                return;
     //*********************************************************
     //    *****************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //*********************************************************
     //     ***********************
     default:   Key=0;
                return;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RichEdit1KeyPress(TObject *Sender, char &Key)
{ int  PositionGlobal, LineNumber, PositionLocal;

  switch(PageControl1->TabIndex)
  { case 0: PositionGlobal=Form1->RichEdit1->SelStart;  //    
            break;
    case 1: PositionGlobal=Form1->RichEdit2->SelStart;  //    
            break;
    case 2: PositionGlobal=Form1->RichEdit3->SelStart;  //    
  }
  LineNumber=PositionGlobal/46;               //  ,      44  + CR+LF
  PositionLocal=PositionGlobal-46*LineNumber; //    
  //************************************************************
  //   Enter *****************************************
  if(Key==0x0D)
  { Key=0;     //  Enter
    return;    //  
  }
  //************************************************************
  //   BackSpace     ************
  ChangeLeftRight(PositionGlobal, PositionLocal, LineNumber, Key);
  if(BS_FLAG) return; //    BackSpace
  //  -  ****************************************
  int MaxLineNumber = (SelectedChip.Size*SelectedChip.ByteInWord-1)/8;
  if(PositionLocal==29)
  { if(LineNumber==MaxLineNumber)  PositionGlobal=5;
    else                           PositionGlobal=(LineNumber+1)*46+5;
    switch(PageControl1->TabIndex)
    { case 0: Form1->RichEdit1->SelStart=PositionGlobal;   //  
              Form1->RichEdit1->SelLength=0;               //  
              break;
      case 1: Form1->RichEdit2->SelStart=PositionGlobal;   //  
              Form1->RichEdit2->SelLength=0;               //  
              break;
      case 2: Form1->RichEdit3->SelStart=PositionGlobal;   //  
              Form1->RichEdit3->SelLength=0;               //  
    }
  }
  if(PositionLocal==44)
  { if(LineNumber==MaxLineNumber)  PositionGlobal=35;
    else                           PositionGlobal=(LineNumber+1)*46+35;
    switch(PageControl1->TabIndex)
    { case 0: Form1->RichEdit1->SelStart=PositionGlobal;   //  
              Form1->RichEdit1->SelLength=0;               //  
              break;
      case 1: Form1->RichEdit2->SelStart=PositionGlobal;   //  
              Form1->RichEdit2->SelLength=0;               //  
              break;
      case 2: Form1->RichEdit3->SelStart=PositionGlobal;   //  
              Form1->RichEdit3->SelLength=0;               //  
    }
  }
  Key=0;
  keybd_event(VK_RIGHT,0,0,0);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//***************************************************************************
//---   -----------------------------------------------------
//---         ---------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ unsigned char buf[2], value[1];
  AnsiString TempStr;
  int  GlobalNumber, BlockNumber, BlockPosition; //  ,  8- ,   8- 
  int i,j;

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     

  //  SS   !      .      ,        .
  wr_buf_len=1;
  switch(SelectedChip.Model)
  { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
            // SS (  SPI        100     )
            wr_buf[0]=0x47;
            break;
    case 13: case 14: case 15: case 16: case 17: case 18:
    case 19: case 20: case 21: case 22:
            //  SS ( AK64xx, 250x0  )
            wr_buf[0]=0x48;
  }
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  Sleep(Delays);//////////
  //***********************************************************************
  // GOTO EWEN MODE IF NEED ***********************************************
  switch(SelectedChip.Model)
  { case 1: case 2: case 3: case 4: case 5: case 6: case 7:  case 8: case 9:
    case 10: case 11: case 12: case 13: case 14: case 15:
           //   
           wr_buf_len=2;
           wr_buf[0]=0x42;     // Send SPI packet size
           switch(SelectedChip.Model)
           { case 1: case 2: case 8: case 9:
                     wr_buf[1]=0x09;     // 0x09 = 9 - packet size = 9 bit
                     break;
             case 3: wr_buf[1]=0x0A;     // 0x0A = 10 - packet size = 10 bit
                     break;
             case 4: case 5: case 10:
                     wr_buf[1]=0x0B;     // 0x0B = 11 - packet size = 11 bit
                     break;
             case 11:wr_buf[1]=0x0C;     // 0x0C = 12 - packet size = 12 bit
                     break;
             case 6: case 7: case 12:
                     wr_buf[1]=0x0D;     // 0x0D = 13 - packet size = 13 bit
                     break;
             case 13: case 14: case 15:
                     wr_buf[1]=0x10;     // 0x10 = 16 - packet size = 16 bit
           }
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           Sleep(Delays);//////////
           //       EWEN
           wr_buf_len=3;
           wr_buf[0]=0x44;     // Load Packet
           switch(SelectedChip.Model)
           { case 1: case 2: case 8: case 9:
                     wr_buf[1]=0x30;     //  
                     wr_buf[2]=0x01;     //  
                     break;
             case 3: wr_buf[1]=0x60;     //   
                     wr_buf[2]=0x02;     //   +   
                     break;
             case 4: case 5: case 10:
                     wr_buf[1]=0xC0;     //   
                     wr_buf[2]=0x04;     //   + 2   
                     break;
             case 11:wr_buf[1]=0x80;     //   
                     wr_buf[2]=0x09;     //   + 3   
                     break;
             case 6: case 7: case 12:
                     wr_buf[1]=0x0;      //   
                     wr_buf[2]=0x13;     //   + 4   
                     break;
             case 13: case 14: case 15:
                     wr_buf[1]=0x0;      //  
                     wr_buf[2]=0xA3;     //  
           }
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           Sleep(Delays);//////////
           //  SS ,     
           wr_buf_len=1;
           switch(SelectedChip.Model)
           { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
                     // SS
                     wr_buf[0]=0x48;
                     break;
             case 13: case 14: case 15:
                     //  SS ( AK64xx  )
                     wr_buf[0]=0x47;
           }
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           //************
           Sleep(Delays);//////////
           Sleep(1);
           //************
           // 
           wr_buf_len=1;
           wr_buf[0]=0x46;
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           //************
           Sleep(Delays);//////////
           Sleep(1);
           //************
           //  SS ,      
           wr_buf_len=1;
           switch(SelectedChip.Model)
           { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
                    // SS (  SPI        100     )
                    wr_buf[0]=0x47;
                    break;
             case 13: case 14: case 15:
                    //  SS ( AK64xx, 250x0  )
                    wr_buf[0]=0x48;
           }
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           Sleep(Delays);//////////
           //   
           wr_buf_len=2;
           wr_buf[0]=0x42;     // Send SPI packet size
           switch(SelectedChip.Model)
           { case 1: case 2: case 8: case 9:
                     wr_buf[1]=0x19;     // 0x19 = 25 - packet size = 25 bit
                     break;
             case 3: wr_buf[1]=0x1A;     // 0x1A = 26 - packet size = 26 bit
                     break;
             case 4: case 5: case 10:
                     wr_buf[1]=0x1B;     // 0x1B = 27 - packet size = 27 bit
                     break;
             case 11:wr_buf[1]=0x1C;     // 0x1C = 28 - packet size = 28 bit
                     break;
             case 6: case 7: case 12:
                     wr_buf[1]=0x1D;     // 0x1D = 29 - packet size = 29 bit
                     break;
             case 13: case 14: case 15:
                     wr_buf[1]=0x20;     // 0x20 = 32 - packet size = 32 bit
           }
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           Sleep(Delays);//////////
    //  25-         ,  ,     ,   
    // case 16: case 17: case 18: case 19: case 20: case 21: case 22:
  }
  //***********************************************************************
  // WRITE ****************************************************************
  for(i=0; i<SelectedChip.Size; i++) //   
  { //       EWEN Mode  25- 
    switch(SelectedChip.Model)
    { case 16: case 17: case 18: case 19: case 20: case 21: case 22:
               //   
               wr_buf_len=2;
               wr_buf[0]=0x42;     // Send SPI packet size
               wr_buf[1]=0x8;      // 8 bit
               if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                                LBar->Free();        //    -
                                ClosePort();
                                return;
                              }
               //************
               Sleep(Delays);//////////
               Sleep(1);
               //************
               //     EWEN Mode
               wr_buf_len=2;
               wr_buf[0]=0x44;     // Load Packet
               wr_buf[1]=0x6;
               if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                                LBar->Free();        //    -
                                ClosePort();
                                return;
                              }
               //************
               Sleep(Delays);//////////
               Sleep(1);
               //************
               //  SS
               wr_buf_len=1;
               wr_buf[0]=0x47;
               if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                                LBar->Free();        //    -
                                ClosePort();
                                return;
                              }
               //************
               Sleep(Delays);//////////
               Sleep(1);
               //************
               //  
               wr_buf_len=1;
               wr_buf[0]=0x46;
               if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                                LBar->Free();        //    -
                                ClosePort();
                                return;
                              }
               //************
               Sleep(Delays);//////////
               Sleep(1);
               //************
               //  SS
               wr_buf_len=1;
               wr_buf[0]=0x48;
               if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                                LBar->Free();        //    -
                                ClosePort();
                                return;
                              }
               Sleep(Delays);//////////
               //   
               wr_buf_len=2;
               wr_buf[0]=0x42;     // Send SPI packet size
               switch(SelectedChip.Model)
               { case 16: case 17: case 18:
                          wr_buf[1]=0x18;     // 24 bits
                          break;
                 case 19: case 20: case 21: case 22:
                          wr_buf[1]=0x20;     // 32 bits
               }
               if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                                LBar->Free();        //    -
                                ClosePort();
                                return;
                              }
               Sleep(Delays);//////////
    }
    //   
    switch(SelectedChip.Model)
    { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8:
      case 9: case 10: case 11: case 12: case 13: case 14: case 15:
             wr_buf_len=5;
             break;
      case 16: case 17: case 18:
             wr_buf_len=4;
             break;
      case 19: case 20: case 21: case 22:
             wr_buf_len=5;
    }
    wr_buf[0]=0x44;            //   
    //   (4 ).   (0-  1-)   -   (   ),   ,  
    //    
    for(j=0; j<SelectedChip.ByteInWord; j++)
    { GlobalNumber=i*SelectedChip.ByteInWord+j; //  ( *   +  )
      BlockNumber=GlobalNumber/8;
      BlockPosition=GlobalNumber-BlockNumber*8;
      switch(PageControl1->TabIndex)
      { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit1->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
                Form1->RichEdit1->SelLength=0;                 //  
                break;
        case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit2->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
                Form1->RichEdit2->SelLength=0;                 //  
                break;
        case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit3->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
                Form1->RichEdit3->SelLength=0;                 //  
      }
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      HexToBin(buf,value,1);                         //    ()
      //     
      wr_buf[SelectedChip.ByteInWord-j-1+1]=value[0];//   - wr_buf[2],  - wr_buf[1]
    }
    switch(SelectedChip.Model)
    { case 1: case 2: case 8: case 9:
               wr_buf[3]=0x40|i;  // 2-  -      
               wr_buf[4]=0x1;     // Start Bit
               break;
       case 3: wr_buf[3]=0x80|i;     // 2-  -        
               wr_buf[4]=0x2;        // Start Bit     
       case 4: case 5: case 10:
               wr_buf[3]=0x0|i;      // 2-  -   
               wr_buf[4]=0x5;        // Start Bit    
               break;
       case 11:wr_buf[3]=0x0|i;      // 2-  -   
               wr_buf[4]=0xA;        // Start Bit    
               break;
       case 6: case 7: case 12:
               wr_buf[3]=0x0|i;      // 2-  -   
               wr_buf[4]=0x14|(i>>8);// Start Bit,        
               break;
       case 13:wr_buf[3]=(i<<1);     // 2-  -   
               wr_buf[4]=0xA4;       //  
               break;
       case 14:wr_buf[3]=i;          // 2-  -   
               wr_buf[4]=0xA4;       //  
               break;
       case 15:wr_buf[3]=i;          // 2-  -   
               wr_buf[4]=0xA4|(i>>8);//  
               break;
       case 16: case 17: case 18:
               wr_buf[2]=i;          // 2-  -   
               wr_buf[3]=2|((i&0x100)>>5);//    9-    4- 
               break;
       case 19: case 20: case 21: case 22:
               wr_buf[2]=i;    //   
               wr_buf[3]=i>>8; //   
               wr_buf[4]=2;    //  
    }
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(Delays);//////////
    //  SS ,     
    wr_buf_len=1;
    switch(SelectedChip.Model)
    { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
              wr_buf[0]=0x48; // SS
              break;
      case 13: case 14: case 15: case 16: case 17: case 18:
      case 19: case 20: case 21: case 22:
              wr_buf[0]=0x47;      //  SS ( AK64xx, 250x0  )
    }
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(Delays);//////////
    //   -
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Size; //    -
    Sleep(1);
    // 
    wr_buf_len=1;
    wr_buf[0]=0x46;
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(Delays);//////////
    //  
    Sleep(10);
    //  SS ,      
    wr_buf_len=1;
    switch(SelectedChip.Model)
    { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
             // SS (  SPI        100     )
             wr_buf[0]=0x47;
             break;
      case 13: case 14: case 15: case 16: case 17: case 18:
      case 19: case 20: case 21: case 22:
             //  SS ( AK64xx  )
             wr_buf[0]=0x48;
    }
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(Delays);//////////
    //  
    Sleep(10);
    // ,     
  }
  //***********************************************************************
  // RETURN TO EWDS MODE IF NEED ******************************************
  switch(SelectedChip.Model)
  { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9:
    case 10: case 11: case 12: case 13: case 14: case 15:
           //    9 
           wr_buf_len=2;
           wr_buf[0]=0x42;     // Send SPI packet size
           switch(SelectedChip.Model)
           { case 1: case 2: case 8: case 9:
                     wr_buf[1]=0x09;     // 0x09 = 9 - packet size = 9 bit
                     break;
             case 3: wr_buf[1]=0x0A;     // 0x0A = 10 - packet size = 10 bit
                     break;
             case 4: case 5: case 10:
                     wr_buf[1]=0x0B;     // 0x0B = 11 - packet size = 11 bit
                     break;
             case 11:wr_buf[1]=0x0C;     // 0x0C = 12 - packet size = 12 bit
                     break;
             case 6: case 7: case 12:
                     wr_buf[1]=0x0D;     // 0x0D = 13 - packet size = 13 bit
                     break;
             case 13: case 14: case 15:
                     wr_buf[1]=0x10;     // 0x10 = 16 - packet size = 16 bit
           }
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           //************
           Sleep(Delays);//////////
           Sleep(1);
           //************
           //       EWDS
           wr_buf[0]=0x44;     // Load Packet
           switch(SelectedChip.Model)
           { case 1: case 2: case 8: case 9:
                     wr_buf_len=3;
                     wr_buf_len=3;
                     wr_buf[1]=0x0;      //  
                     wr_buf[2]=0x01;     //  
                     break;
             case 3: wr_buf_len=3;
                     wr_buf[1]=0x0;      //  
                     wr_buf[2]=0x02;     //   +   
                     break;
             case 4: case 5: case 10:
                     wr_buf_len=3;
                     wr_buf[1]=0x0;      //  
                     wr_buf[2]=0x04;     //   +   
                     break;
             case 11:wr_buf_len=3;
                     wr_buf[1]=0x0;      //  
                     wr_buf[2]=0x08;     //   +   
                     break;
             case 6: case 7: case 12:
                     wr_buf_len=3;
                     wr_buf[1]=0x0;      //  
                     wr_buf[2]=0x10;     //   +   
                     break;
             case 13: case 14: case 15:
                     wr_buf_len=3;
                     wr_buf[1]=0x0;      //  
                     wr_buf[2]=0xA0;     //  
           }
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           //************
           Sleep(Delays);//////////
           Sleep(1);
           //************
           //  SS ,     
           wr_buf_len=1;
           switch(SelectedChip.Model)
           { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
                    wr_buf[0]=0x48; // SS
                    break;
             case 13: case 14: case 15:
                    wr_buf[0]=0x47; //  SS ( AK64xx, 250x0  )
           }
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           //************
           Sleep(Delays);//////////
           Sleep(1);
           //************
           // 
           wr_buf_len=1;
           wr_buf[0]=0x46;
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           //************
           Sleep(Delays);//////////
           Sleep(1);
           //************
           //  SS ,      
           wr_buf_len=1;
           switch(SelectedChip.Model)
           { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
                     // SS (  SPI        100     )
                     wr_buf[0]=0x47;
                     break;
             case 13: case 14: case 15:
                     //  SS ( AK64xx, 250x0  )
                     wr_buf[0]=0x48;
           }
           if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                            LBar->Free();        //    -
                            ClosePort();
                            return;
                          }
           Sleep(Delays);//////////
    //  25-      ,     
    // case 16: case 17: case 18: case 19: case 20: case 21: case 22:
  }
  //***********************************************************************
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//***************************************************************************
//---   -----------------------------------------------------
//---         --------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ char buf[2], value[1], hexbuf[3];
  AnsiString TempStr;
  int  GlobalNumber, BlockNumber, BlockPosition;  //  ,  8- ,   8- 

  // -
  Application->CreateForm(__classid(TLBar),&LBar); //    -
  LBar->Show();                   //     
  //  SS   !      .      ,        .
  wr_buf_len=1;
  switch(SelectedChip.Model)
  { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
            // SS (  SPI        100     )
            wr_buf[0]=0x47;
            break;
    case 13: case 14: case 15: case 16: case 17: case 18:
    case 19: case 20: case 21: case 22:
            //  SS ( AK64xx, 250x0  )
            wr_buf[0]=0x48;
  }
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  //************
  Sleep(Delays);//////////
  Sleep(1);
  //*************************************************************************
  //   
  wr_buf_len=2;
  wr_buf[0]=0x42;     // Send SPI packet size
  switch(SelectedChip.Model)
  { case 1: case 2: case 8: case 9:
            wr_buf[1]=0x19;     // 0x19 = 25 - packet size = 25 bit
            break;
    case 3: wr_buf[1]=0x1A;     // 0x1A = 26 - packet size = 26 bit
            break;
    case 4: case 5: case 10:
            wr_buf[1]=0x1B;     // 0x1B = 27 - packet size = 27 bit
            break;
    case 11:wr_buf[1]=0x1C;     // 0x1C = 28 - packet size = 28 bit
            break;
    case 6: case 7: case 12:
            wr_buf[1]=0x1D;     // 0x1D = 29 - packet size = 29 bit
            break;
    case 13: case 14: case 15:
            wr_buf[1]=0x20;     // 0x20 = 32 - packet size = 32 bit
            break;
    case 16: case 17: case 18:
            wr_buf[1]=0x18;     // 0x18 = 24 - packet size = 24 bit
            break;
    case 19: case 20: case 21: case 22:
            wr_buf[1]=0x20;     // 0x20 = 32 - packet size = 32 bit
  }
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   LBar->Free();        //    -
                   ClosePort();
                   return;
                 }
  //************
  Sleep(Delays);//////////
  Sleep(1);
  // READ *******************************************************************
  for(int i=0; i<SelectedChip.Size; i++) //   
  { //   
    switch(SelectedChip.Model)
    { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8:
      case 9: case 10: case 11: case 12: case 13: case 14: case 15:
              wr_buf_len=5;
              break;
      case 16: case 17: case 18:
              wr_buf_len=4;
              break;
      case 19: case 20: case 21: case 22:
              wr_buf_len=5;
    }
    //   
    wr_buf[0]=0x44;
    //   (4 ).   (0-  1-)    (   )
    wr_buf[1]=0x0;
    wr_buf[2]=0x0;
    switch(SelectedChip.Model)
    { case 1: case 2: case 8: case 9:
               wr_buf[3]=0x80|i;     // 2-  -      
               wr_buf[4]=0x1;        // Start Bit
               break;
       case 3: wr_buf[3]=0x0|i;      // 2-  -        
               wr_buf[4]=0x3;        // Start Bit     
               break;
       case 4: case 5: case 10:
               wr_buf[3]=0x0|i;      // 2-  -   
               wr_buf[4]=0x6;        // Start Bit    
               break;
       case 11:wr_buf[3]=0x0|i;      // 2-  -   
               wr_buf[4]=0x0C;       // Start Bit    
               break;
       case 6: case 7: case 12:
               wr_buf[3]=0x0|i;      // 2-  -   
               wr_buf[4]=0x18|(i>>8);// Start Bit,        
               break;
       case 13:wr_buf[3]=(i<<1);     // 2-  -   
               wr_buf[4]=0xA8;       //  
               break;
       case 14:wr_buf[3]=i;          // 2-  -   
               wr_buf[4]=0xA8;       //  
               break;
       case 15:wr_buf[3]=i;          // 2-  -   
               wr_buf[4]=0xA8|(i>>8);//  
               break;
       case 16: case 17: case 18:
               wr_buf[2]=i;          // 2-  -   
               wr_buf[3]=0x3|((i&0x100)>>5);//      
               break;
       case 19: case 20: case 21: case 22:
               wr_buf[2]=i;     //   
               wr_buf[3]=i>>8;  //   
               wr_buf[4]=0x3;   //  
    }
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    //************
    Sleep(Delays);//////////
    Sleep(1);
    //************
    //  SS ,     
    wr_buf_len=1;
    switch(SelectedChip.Model)
    { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
              wr_buf[0]=0x48;      // SS
              break;
      case 13: case 14: case 15: case 16: case 17: case 18:
      case 19: case 20: case 21: case 22:
              wr_buf[0]=0x47;             //  SS ( AK64xx, 250x0  )
    }
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    //************
    Sleep(Delays);//////////
    Sleep(1);
    //************
    // 
    wr_buf_len=1;
    wr_buf[0]=0x46;
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    //************
    Sleep(Delays);//////////
    Sleep(2);
    //************
    //  SS ,      
    wr_buf_len=1;
    switch(SelectedChip.Model)
    { case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11: case 12:
             // SS (  SPI        100     )
             wr_buf[0]=0x47;
             break;
      case 13: case 14: case 15: case 16: case 17: case 18:
      case 19: case 20: case 21: case 22:
             //  SS ( AK64xx, 250x0  )
             wr_buf[0]=0x48;
    }
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    //************
    Sleep(Delays);//////////
    Sleep(1);
    //************
    //   
    wr_buf_len=1;
    wr_buf[0]=0x45;  //  
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     LBar->Free();        //    -
                     ClosePort();
                     return;
                   }
    Sleep(Delays);//////////
    // 
    if(!ReadFrom(8)){ MessageBox(NULL,"  ","Error",MB_OK);
                      LBar->Free();        //    -
                      ClosePort();
                      return;
                    }
    //************
    Sleep(Delays);//////////
    Sleep(1);
    //************
    //   -
    LBar->ProgressBar1->Position=100*(i+1)/SelectedChip.Size; //    -
    //     (ByteInWord   )
    for(int j=0; j<SelectedChip.ByteInWord; j++)
    { GlobalNumber=i*SelectedChip.ByteInWord+j; //  ( *   +  )
      BlockNumber=GlobalNumber/8;
      BlockPosition=GlobalNumber-BlockNumber*8;
      //    (    ,  )
         memset(buf,0,2);                            //  
         buf[0]=rd_buf[SelectedChip.ByteInWord-j-1]; //     
         if(rd_buf[SelectedChip.ByteInWord-j-1]<0x1F) buf[0]=0x1F;  //,  
         switch(PageControl1->TabIndex)
         { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+36+BlockPosition; //        
                   Form1->RichEdit1->SelLength=1;           //  1 
                   Form1->RichEdit1->SelText=buf;           //    
                   break;
           case 1: Form1->RichEdit2->SelStart=BlockNumber*46+36+BlockPosition; //        
                   Form1->RichEdit2->SelLength=1;           //  1 
                   Form1->RichEdit2->SelText=buf;           //    
                   break;
           case 2: Form1->RichEdit3->SelStart=BlockNumber*46+36+BlockPosition; //        
                   Form1->RichEdit3->SelLength=1;           //  1 
                   Form1->RichEdit3->SelText=buf;           //    
         }
      //  
         value[0]=rd_buf[SelectedChip.ByteInWord-j-1];
         BinToHex(value,hexbuf,1);                       //    ()
         hexbuf[2]=0;                                    //   
         switch(PageControl1->TabIndex)
         { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                   Form1->RichEdit1->SelLength=2;                  //  2 
                   Form1->RichEdit1->SelText=hexbuf;
                   break;
           case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                   Form1->RichEdit2->SelLength=2;                  //  2 
                   Form1->RichEdit2->SelText=hexbuf;
                   break;
           case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                   Form1->RichEdit3->SelLength=2;                  //  2 
                   Form1->RichEdit3->SelText=hexbuf;
         }
    }
    // ,     
  }
  //*************************************************************************
  LBar->Free();        //    -
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---     ------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{ int Namelength; AnsiString Ext;
  char buf[2], value[1], hexbuf[3]; unsigned char rffch[1]; // readed from file char
  AnsiString TempStr;
  int  BlockNumber, BlockPosition;  //  ,  8- ,   8- 

  if(OpenDialog1->Execute())
  { FilePath=OpenDialog1->FileName;          //    
    Namelength=FilePath.Length();            //      
    Ext=FilePath.SubString(Namelength-2,3);  // 
    Ext=UpperCase(Ext);                      //    

    // -
    Application->CreateForm(__classid(TLBar),&LBar); //    -
    LBar->Show();                   //     

    //  hex-
    if(Ext=="HEX")
    { Memo1->Lines->LoadFromFile(FilePath);
      LoadHexFile();
      Memo1->Clear();
    }
    //  bin-
    else
    { TFileStream* fs=new TFileStream(FilePath,fmOpenRead);
      for(int i=0; i<SelectedChip.Size*SelectedChip.ByteInWord; i++)
      { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
        if(fs->Read(rffch,1))  //    
        { //   
          memset(buf,0,2);             //  
          buf[0]=rffch[0];                //     
          if(rffch[0]<0x1F) buf[0]=0x1F;  //,  
          switch(PageControl1->TabIndex)
          { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+36+BlockPosition; //        
                    Form1->RichEdit1->SelLength=1;           //  1 
                    Form1->RichEdit1->SelText=buf;           //    
                    break;
            case 1: Form1->RichEdit2->SelStart=BlockNumber*46+36+BlockPosition; //        
                    Form1->RichEdit2->SelLength=1;           //  1 
                    Form1->RichEdit2->SelText=buf;           //    
                    break;
            case 2: Form1->RichEdit3->SelStart=BlockNumber*46+36+BlockPosition; //        
                    Form1->RichEdit3->SelLength=1;           //  1 
                    Form1->RichEdit3->SelText=buf;           //    
          }
          //  
          value[0]=rffch[0];
          BinToHex(value,hexbuf,1);                       //    ()
          hexbuf[2]=0;                                    //   
          switch(PageControl1->TabIndex)
          { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                    Form1->RichEdit1->SelLength=2;                  //  2 
                    Form1->RichEdit1->SelText=hexbuf;
                    break;
            case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                    Form1->RichEdit2->SelLength=2;                  //  2 
                    Form1->RichEdit2->SelText=hexbuf;
                    break;
            case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition; //     
                    Form1->RichEdit3->SelLength=2;                  //  2 
                    Form1->RichEdit3->SelText=hexbuf;
          }
        }
        else i=SelectedChip.Size*SelectedChip.ByteInWord; //   
        if(i%16==0)
        { LBar->ProgressBar1->Position=100*i/SelectedChip.Size; //    -
        }
      }
      Form1->StaticText1->Caption=FilePath;
      delete fs;
    }
    // -
    LBar->Free();        //    -
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Saveas1Click(TObject *Sender)
{ int Namelength; AnsiString Ext;
  char buf[2], value[1];
  AnsiString TempStr;
  unsigned char CheckSum[1];
  int  BlockNumber, BlockPosition;  //  ,  8- ,   8- 

  if(SaveDialog1->Execute())        //     
  { FilePath=SaveDialog1->FileName; //     
    Namelength=FilePath.Length();            //      
    Ext=FilePath.SubString(Namelength-2,3);  // 
    Ext=UpperCase(Ext);                      //    

    if(SaveDialog1->FilterIndex == 1)
    { //   BIN (     )
      if(Ext!="BIN")                           //     bin
      { FilePath = FilePath + ".bin";   }      //    .bin

      // -
      Application->CreateForm(__classid(TLBar),&LBar); //    -
      LBar->Show();                   //     

      Form1->RichEdit1->Visible=false; Form1->RichEdit2->Visible=false; Form1->RichEdit3->Visible=false;
      TFileStream* fs=new TFileStream(FilePath,fmCreate|fmOpenWrite);
      for(int i=0; i<SelectedChip.Size*SelectedChip.ByteInWord; i++)
      { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
        switch(PageControl1->TabIndex)
        { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                  Form1->RichEdit1->SelLength=2;                 //  2 
                  TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
                  Form1->RichEdit1->SelLength=0;                 //  
                  break;
          case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                  Form1->RichEdit2->SelLength=2;                 //  2 
                  TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
                  Form1->RichEdit2->SelLength=0;                 //  
                  break;
          case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                  Form1->RichEdit3->SelLength=2;                 //  2 
                  TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
                  Form1->RichEdit3->SelLength=0;                 //  
        }
        memset(buf,0,2);                               //  
        strcat(buf,TempStr.c_str());                   //      (  )
        HexToBin(buf,value,1);                         //    ()
        fs->Write(value,1);                            //  
        if(i%16==0)
        { LBar->ProgressBar1->Position=100*i/(SelectedChip.Size*SelectedChip.ByteInWord); //    -
        }
      }
      delete fs;
      Form1->RichEdit1->Visible=true; Form1->RichEdit2->Visible=true; Form1->RichEdit3->Visible=true;
      // -
      LBar->Free();        //    -
    }
    else
    { //   HEX (   BIN)
      if(Ext!="HEX")                           //     hex
      { FilePath = FilePath + ".hex";   }      //    .hex

      // -
      Application->CreateForm(__classid(TLBar),&LBar); //    -
      LBar->Show();                   //     

      Form1->RichEdit1->Visible=false; Form1->RichEdit2->Visible=false; Form1->RichEdit3->Visible=false;
      TFileStream* fs=new TFileStream(FilePath,fmCreate|fmOpenWrite);
      //   HEX-
      for(int i=0; i<SelectedChip.Size*SelectedChip.ByteInWord; i++)
      { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
        if(i%16==0)      //   ,     i  16  0
        { CheckSum[0]=0x10;          // CheckSum      (RECLEN)
          fs->Write(":10",3);        //    -  (:)  RECLEN (0x10 = 16 )
          // 
          value[0]=i/256;            //  
          CheckSum[0]=CheckSum[0]+value[0]; //     
          BinToHex(value,buf,1);     //  ()  
          fs->Write(buf,2);          //   HEX-   

          value[0]=i;                //  
          CheckSum[0]=CheckSum[0]+value[0]; //     
          BinToHex(value,buf,1);     //  ()  
          fs->Write(buf,2);          //   HEX-   

          buf[0]=0x30;               //   RECTYPE
          buf[1]=0x30;               //"00" - DATA RECORD  ( 0x30="0")
          fs->Write(buf,2);          //   
        }
        switch(PageControl1->TabIndex)
        { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                  Form1->RichEdit1->SelLength=2;                 //  2 
                  TempStr=Form1->RichEdit1->SelText;             //    
                  Form1->RichEdit1->SelLength=0;                 //  
                  break;
          case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                  Form1->RichEdit2->SelLength=2;                 //  2 
                  TempStr=Form1->RichEdit2->SelText;             //    
                  Form1->RichEdit2->SelLength=0;                 //  
                  break;
          case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                  Form1->RichEdit3->SelLength=2;                 //  2 
                  TempStr=Form1->RichEdit3->SelText;             //    
                  Form1->RichEdit3->SelLength=0;                 //  
        }
        memset(buf,0,2);                               //  
        strcat(buf,TempStr.c_str());                   //      (  )
        fs->Write(buf,2);                              //    2 

        TempStr=LowerCase(TempStr);                    //    ( HexToBin)
        memset(buf,0,2);                               //  
        strcat(buf,TempStr.c_str());                   //      (  )
        HexToBin(buf,value,1);                         //    ()
        //  CheckSum
        CheckSum[0]=CheckSum[0]+value[0];
        //       -    CheckSum +         
        if((i+1)%16==0) //     i+1  16  0
        {  CheckSum[0]=255-CheckSum[0];
           CheckSum[0]=CheckSum[0]+1;
           value[0]=CheckSum[0];
           BinToHex(value,buf,1);     //  ()  
           fs->Write(buf,2);          //  (CheckSum)  
           value[0]=0xD;                //    
           fs->Write(value,1);
           value[0]=0xA;
           fs->Write(value,1);
        }
        if(i%16==0)
        { LBar->ProgressBar1->Position=100*i/(SelectedChip.Size*SelectedChip.ByteInWord); //    -
        }
      }
      //      
      fs->Write(":00000001FF",11);                        //  
      delete fs;
      Form1->RichEdit1->Visible=true; Form1->RichEdit2->Visible=true; Form1->RichEdit3->Visible=true;
      // -
      LBar->Free();        //    -
    }
    Form1->StaticText1->Caption=FilePath;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{ char buf[2], value[1];  int Namelength;
  AnsiString TempStr, Ext;
  int  BlockNumber, BlockPosition;  //  ,  8- ,   8- 
  TFileStream* fs;
  bool NeedBin, NeedHex;
  unsigned char CheckSum[1];

  NeedBin=false;
  NeedHex=false;
  Namelength=FilePath.Length();            //      

  if(Namelength)      //   
  { if(MessageBox(Form1->Handle,"   , ?","", MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
    { Ext=FilePath.SubString(Namelength-2,3);  // 
      Ext=UpperCase(Ext);                      //    
      //   
      if(Ext=="BIN")            //  bin- -   bin
      { NeedBin=true;   }
      else                      //   hex-
      { NeedHex=true;   }
    }
  }
  else if(SaveDialog1->Execute()) //     (  )
  { FilePath=SaveDialog1->FileName;
    Namelength=FilePath.Length();            //      
    Ext=FilePath.SubString(Namelength-2,3);  // 
    Ext=UpperCase(Ext);                      //    
    //  (  )
    if(SaveDialog1->FilterIndex == 1)
    { //   BIN (     )
      if(Ext!="BIN")                           //     bin
      { FilePath = FilePath + ".bin";   }      //    .bin
      NeedBin=true;
    }
    else
    { //   HEX (   BIN)
      if(Ext!="HEX")                           //     hex
      { FilePath = FilePath + ".hex";   }      //    .hex
      NeedHex=true;
    }
  }
  //---------------------------
  // , , 
  if(NeedBin)         //     bin
  { // -
    Application->CreateForm(__classid(TLBar),&LBar); //    -
    LBar->Show();                   //     

    Form1->RichEdit1->Visible=false; Form1->RichEdit2->Visible=false; Form1->RichEdit3->Visible=false;
    TFileStream* fs=new TFileStream(FilePath,fmCreate|fmOpenWrite);
    for(int i=0; i<SelectedChip.Size*SelectedChip.ByteInWord; i++)
    { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
      switch(PageControl1->TabIndex)
      { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit1->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit1->SelText);  //    
                Form1->RichEdit1->SelLength=0;                 //  
                break;
        case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit2->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit2->SelText);  //    
                Form1->RichEdit2->SelLength=0;                 //  
                break;
        case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit3->SelLength=2;                 //  2 
                TempStr=LowerCase(Form1->RichEdit3->SelText);  //    
                Form1->RichEdit3->SelLength=0;                 //  
      }
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      HexToBin(buf,value,1);                         //    ()
      fs->Write(value,1);                            //  
      if(i%16==0)
      { LBar->ProgressBar1->Position=100*i/(SelectedChip.Size*SelectedChip.ByteInWord); //    -
      }
    }
    delete fs;
    Form1->RichEdit1->Visible=true; Form1->RichEdit2->Visible=true; Form1->RichEdit3->Visible=true;
    Form1->StaticText1->Caption=FilePath;
    // -
    LBar->Free();        //    -
  }
  if(NeedHex)         //    hex
  { Application->CreateForm(__classid(TLBar),&LBar); //    -
    LBar->Show();                   //     

    Form1->RichEdit1->Visible=false; Form1->RichEdit2->Visible=false; Form1->RichEdit3->Visible=false;
    TFileStream* fs=new TFileStream(FilePath,fmCreate|fmOpenWrite);
    for(int i=0; i<SelectedChip.Size*SelectedChip.ByteInWord; i++)
    { BlockNumber=i/8; BlockPosition=i-BlockNumber*8;
      if(i%16==0)      //   ,     i  16  0
      { CheckSum[0]=0x10;          // CheckSum      (RECLEN)
        fs->Write(":10",3);        //    -  (:)  RECLEN (0x10 = 16 )
        // 
        value[0]=i/256;            //  
        CheckSum[0]=CheckSum[0]+value[0]; //     
        BinToHex(value,buf,1);     //  ()  
        fs->Write(buf,2);          //   HEX-   

        value[0]=i;                //  
        CheckSum[0]=CheckSum[0]+value[0]; //     
        BinToHex(value,buf,1);     //  ()  
        fs->Write(buf,2);          //   HEX-   

        buf[0]=0x30;               //   RECTYPE
        buf[1]=0x30;               //"00" - DATA RECORD  ( 0x30="0")
        fs->Write(buf,2);          //   
      }
      switch(PageControl1->TabIndex)
      { case 0: Form1->RichEdit1->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit1->SelLength=2;                 //  2 
                TempStr=Form1->RichEdit1->SelText;             //    
                Form1->RichEdit1->SelLength=0;                 //  
                break;
        case 1: Form1->RichEdit2->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit2->SelLength=2;                 //  2 
                TempStr=Form1->RichEdit2->SelText;             //    
                Form1->RichEdit2->SelLength=0;                 //  
                break;
        case 2: Form1->RichEdit3->SelStart=BlockNumber*46+6+3*BlockPosition;//     
                Form1->RichEdit3->SelLength=2;                 //  2 
                TempStr=Form1->RichEdit3->SelText;             //    
                Form1->RichEdit3->SelLength=0;                 //  
      }
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      fs->Write(buf,2);                              //    2 

      TempStr=LowerCase(TempStr);                    //    ( HexToBin)
      memset(buf,0,2);                               //  
      strcat(buf,TempStr.c_str());                   //      (  )
      HexToBin(buf,value,1);                         //    ()
      //  CheckSum
      CheckSum[0]=CheckSum[0]+value[0];
      //       -    CheckSum +         
      if((i+1)%16==0) //     i+1  16  0
      {  CheckSum[0]=255-CheckSum[0];
         CheckSum[0]=CheckSum[0]+1;
         value[0]=CheckSum[0];
         BinToHex(value,buf,1);     //  ()  
         fs->Write(buf,2);          //  (CheckSum)  
         value[0]=0xD;                //    
         fs->Write(value,1);
         value[0]=0xA;
         fs->Write(value,1);
      }
      if(i%16==0)
      { LBar->ProgressBar1->Position=100*i/(SelectedChip.Size*SelectedChip.ByteInWord); //    -
      }
    }
    //      
    fs->Write(":00000001FF",11);                        //  
    delete fs;
    Form1->RichEdit1->Visible=true; Form1->RichEdit2->Visible=true; Form1->RichEdit3->Visible=true;
    Form1->StaticText1->Caption=FilePath;
    // -
    LBar->Free();        //    -
  }
}
//---------------------------------------------------------------------------
//---       RH-0004 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RH00041Click(TObject *Sender)
{ SelectedProgrammer = 1;       //  RH-0004
  SwitchToSelectedHW(SelectedProgrammer);       //      
  Form1->Button4->Click();      //   Disconnect
}
//---------------------------------------------------------------------------
//---       RH-0010 -----------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::RH00101Click(TObject *Sender)
{ SelectedProgrammer = 2;       //  RH-0010
  SwitchToSelectedHW(SelectedProgrammer);       //      
  Form1->Button4->Click();      //   Disconnect
}
//---------------------------------------------------------------------------
//---   -,    -----------
//---------------------------------------------------------------------------
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{ Delays = Form1->TrackBar1->Position;  //    
}
//---------------------------------------------------------------------------

